// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/ForceResistance.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__FORCE_RESISTANCE__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__FORCE_RESISTANCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/ForceResistance in the package rcss3d_agent_msgs.
/**
  * The force that acts on a body. [px, py, pz] describes the point of origin relative to the body
  * itself and [fx, fy, fz] describes the resulting force on this point. The two vectors are just
  * an approximation about the real applied force. The point of origin is calculated as weighted
  * average of all contact points to which the force is applied, while the force vector represents
  * the total force applied to all of these contact points. The information to a force resistance
  * perceptor is just sent in case of a present collision of the corresponding body with another
  * simulation object. If there is no force applied, the message of this perceptor is omitted.
 */
typedef struct rcss3d_agent_msgs__msg__ForceResistance
{
  /// The name of the body, to which the force resistance perceptor belongs
  rosidl_runtime_c__String name;
  /// The local x coordinate of the origin of the applied force in meters
  float px;
  /// The local y coordinate of the origin of the applied force in meters
  float py;
  /// The local z coordinate of the origin of the applied force in meters
  float pz;
  /// The x component of the force vector in newton (kg m/s2)
  float fx;
  /// The y component of the force vector in newton (kg m/s2)
  float fy;
  /// The z component of the force vector in newton (kg m/s2)
  float fz;
} rcss3d_agent_msgs__msg__ForceResistance;

// Struct for a sequence of rcss3d_agent_msgs__msg__ForceResistance.
typedef struct rcss3d_agent_msgs__msg__ForceResistance__Sequence
{
  rcss3d_agent_msgs__msg__ForceResistance * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__ForceResistance__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__FORCE_RESISTANCE__STRUCT_H_
